#ifndef LIDAR_TRACKER_ESTIMATOR_H_
#define LIDAR_TRACKER_ESTIMATOR_H_

//#include <memory>

// #include "lidar_tracker.pb.h"
#include "types.h"
#include "point_cv_kalman_filter.h"
//#include <string>

namespace lidar_tracker {

class Estimator {
 public:
  Estimator() = default;

  void Init(double x, double y, double vx, double vy, double timestamp);

  std::pair<Eigen::Vector4d, Eigen::Matrix4d> ComputePrediction(
      double timestamp) const;

  void PredictAndUpdate(const ObservationProto& observation);

  double x() const;
  double y() const;
  double vx() const;
  double vy() const;
  Eigen::Vector2d pos();
  Eigen::Vector2d vel();

 private:
  PointCvKalmanFilter kf_;
  double kf_timestamp_;
};

}  // namespace lidar_tracker

#endif  // LIDAR_TRACKER_ESTIMATOR_H_
